/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.WeightedMetric;

import edu.kit.ipd.descartes.perfdatarepo.MetricType;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Weighted Metric</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightedMetricImpl#getWeight <em>Weight</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightedMetricImpl#getMetricType <em>Metric Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class WeightedMetricImpl extends EntityImpl implements WeightedMetric {
    /**
	 * The default value of the '{@link #getWeight() <em>Weight</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getWeight()
	 * @generated
	 * @ordered
	 */
    protected static final double WEIGHT_EDEFAULT = 0.0;

    /**
	 * The cached value of the '{@link #getWeight() <em>Weight</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getWeight()
	 * @generated
	 * @ordered
	 */
    protected double weight = WEIGHT_EDEFAULT;

    /**
	 * The cached value of the '{@link #getMetricType() <em>Metric Type</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getMetricType()
	 * @generated
	 * @ordered
	 */
    protected MetricType metricType;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected WeightedMetricImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.WEIGHTED_METRIC;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public double getWeight() {
		return weight;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setWeight(double newWeight) {
		double oldWeight = weight;
		weight = newWeight;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.WEIGHTED_METRIC__WEIGHT, oldWeight, weight));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public MetricType getMetricType() {
		if (metricType != null && metricType.eIsProxy()) {
			InternalEObject oldMetricType = (InternalEObject)metricType;
			metricType = (MetricType)eResolveProxy(oldMetricType);
			if (metricType != oldMetricType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.WEIGHTED_METRIC__METRIC_TYPE, oldMetricType, metricType));
			}
		}
		return metricType;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public MetricType basicGetMetricType() {
		return metricType;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setMetricType(MetricType newMetricType) {
		MetricType oldMetricType = metricType;
		metricType = newMetricType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.WEIGHTED_METRIC__METRIC_TYPE, oldMetricType, metricType));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTED_METRIC__WEIGHT:
				return getWeight();
			case AdaptationPackage.WEIGHTED_METRIC__METRIC_TYPE:
				if (resolve) return getMetricType();
				return basicGetMetricType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTED_METRIC__WEIGHT:
				setWeight((Double)newValue);
				return;
			case AdaptationPackage.WEIGHTED_METRIC__METRIC_TYPE:
				setMetricType((MetricType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTED_METRIC__WEIGHT:
				setWeight(WEIGHT_EDEFAULT);
				return;
			case AdaptationPackage.WEIGHTED_METRIC__METRIC_TYPE:
				setMetricType((MetricType)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTED_METRIC__WEIGHT:
				return weight != WEIGHT_EDEFAULT;
			case AdaptationPackage.WEIGHTED_METRIC__METRIC_TYPE:
				return metricType != null;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (weight: ");
		result.append(weight);
		result.append(')');
		return result.toString();
	}

} //WeightedMetricImpl
