/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Dependency Propagation Relationship</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl#getIndependent <em>Independent</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl#getDependent <em>Dependent</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl#getIndependentComponentInstanceReferences <em>Independent Component Instance References</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyPropagationRelationshipImpl#getDependentComponentInstanceReference <em>Dependent Component Instance Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DependencyPropagationRelationshipImpl extends RelationshipImpl implements DependencyPropagationRelationship {
	/**
	 * The cached value of the '{@link #getIndependent() <em>Independent</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndependent()
	 * @generated
	 * @ordered
	 */
	protected EList<InfluencingParameter> independent;

	/**
	 * The cached value of the '{@link #getDependent() <em>Dependent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDependent()
	 * @generated
	 * @ordered
	 */
	protected InfluencingParameter dependent;

	/**
	 * The cached value of the '{@link #getIndependentComponentInstanceReferences() <em>Independent Component Instance References</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndependentComponentInstanceReferences()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentInstanceReference> independentComponentInstanceReferences;

	/**
	 * The cached value of the '{@link #getDependentComponentInstanceReference() <em>Dependent Component Instance Reference</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDependentComponentInstanceReference()
	 * @generated
	 * @ordered
	 */
	protected ComponentInstanceReference dependentComponentInstanceReference;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DependencyPropagationRelationshipImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InfluencingParameter> getIndependent() {
		if (independent == null) {
			independent = new EObjectResolvingEList<InfluencingParameter>(InfluencingParameter.class, this, ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT);
		}
		return independent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencingParameter getDependent() {
		if (dependent != null && dependent.eIsProxy()) {
			InternalEObject oldDependent = (InternalEObject)dependent;
			dependent = (InfluencingParameter)eResolveProxy(oldDependent);
			if (dependent != oldDependent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT, oldDependent, dependent));
			}
		}
		return dependent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencingParameter basicGetDependent() {
		return dependent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDependent(InfluencingParameter newDependent) {
		InfluencingParameter oldDependent = dependent;
		dependent = newDependent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT, oldDependent, dependent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentInstanceReference> getIndependentComponentInstanceReferences() {
		if (independentComponentInstanceReferences == null) {
			independentComponentInstanceReferences = new EObjectContainmentEList<ComponentInstanceReference>(ComponentInstanceReference.class, this, ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES);
		}
		return independentComponentInstanceReferences;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentInstanceReference getDependentComponentInstanceReference() {
		return dependentComponentInstanceReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDependentComponentInstanceReference(ComponentInstanceReference newDependentComponentInstanceReference, NotificationChain msgs) {
		ComponentInstanceReference oldDependentComponentInstanceReference = dependentComponentInstanceReference;
		dependentComponentInstanceReference = newDependentComponentInstanceReference;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE, oldDependentComponentInstanceReference, newDependentComponentInstanceReference);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDependentComponentInstanceReference(ComponentInstanceReference newDependentComponentInstanceReference) {
		if (newDependentComponentInstanceReference != dependentComponentInstanceReference) {
			NotificationChain msgs = null;
			if (dependentComponentInstanceReference != null)
				msgs = ((InternalEObject)dependentComponentInstanceReference).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE, null, msgs);
			if (newDependentComponentInstanceReference != null)
				msgs = ((InternalEObject)newDependentComponentInstanceReference).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE, null, msgs);
			msgs = basicSetDependentComponentInstanceReference(newDependentComponentInstanceReference, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE, newDependentComponentInstanceReference, newDependentComponentInstanceReference));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES:
				return ((InternalEList<?>)getIndependentComponentInstanceReferences()).basicRemove(otherEnd, msgs);
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE:
				return basicSetDependentComponentInstanceReference(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT:
				return getIndependent();
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT:
				if (resolve) return getDependent();
				return basicGetDependent();
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES:
				return getIndependentComponentInstanceReferences();
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE:
				return getDependentComponentInstanceReference();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT:
				getIndependent().clear();
				getIndependent().addAll((Collection<? extends InfluencingParameter>)newValue);
				return;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT:
				setDependent((InfluencingParameter)newValue);
				return;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES:
				getIndependentComponentInstanceReferences().clear();
				getIndependentComponentInstanceReferences().addAll((Collection<? extends ComponentInstanceReference>)newValue);
				return;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE:
				setDependentComponentInstanceReference((ComponentInstanceReference)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT:
				getIndependent().clear();
				return;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT:
				setDependent((InfluencingParameter)null);
				return;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES:
				getIndependentComponentInstanceReferences().clear();
				return;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE:
				setDependentComponentInstanceReference((ComponentInstanceReference)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT:
				return independent != null && !independent.isEmpty();
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT:
				return dependent != null;
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES:
				return independentComponentInstanceReferences != null && !independentComponentInstanceReferences.isEmpty();
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE:
				return dependentComponentInstanceReference != null;
		}
		return super.eIsSet(featureID);
	}

} //DependencyPropagationRelationshipImpl
