/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.containerrepository.ContainerTemplate;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification;

import edu.kit.ipd.descartes.mm.resourcelandscape.Container;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;
import edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Container</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl#getContains <em>Contains</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl#getConfigSpec <em>Config Spec</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl#getTemplate <em>Template</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ContainerImpl extends EntityImpl implements Container {
	/**
     * The cached value of the '{@link #getContains() <em>Contains</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getContains()
     * @generated
     * @ordered
     */
	protected EList<RuntimeEnvironment> contains;

	/**
     * The cached value of the '{@link #getConfigSpec() <em>Config Spec</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getConfigSpec()
     * @generated
     * @ordered
     */
	protected EList<ConfigurationSpecification> configSpec;

	/**
     * The cached value of the '{@link #getTemplate() <em>Template</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getTemplate()
     * @generated
     * @ordered
     */
	protected ContainerTemplate template;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected ContainerImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return ResourcelandscapePackage.Literals.CONTAINER;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<RuntimeEnvironment> getContains() {
        if (contains == null) {
            contains = new EObjectContainmentWithInverseEList<RuntimeEnvironment>(RuntimeEnvironment.class, this, ResourcelandscapePackage.CONTAINER__CONTAINS, ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN);
        }
        return contains;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<ConfigurationSpecification> getConfigSpec() {
        if (configSpec == null) {
            configSpec = new EObjectContainmentEList<ConfigurationSpecification>(ConfigurationSpecification.class, this, ResourcelandscapePackage.CONTAINER__CONFIG_SPEC);
        }
        return configSpec;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ContainerTemplate getTemplate() {
        if (template != null && template.eIsProxy()) {
            InternalEObject oldTemplate = (InternalEObject)template;
            template = (ContainerTemplate)eResolveProxy(oldTemplate);
            if (template != oldTemplate) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, ResourcelandscapePackage.CONTAINER__TEMPLATE, oldTemplate, template));
            }
        }
        return template;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ContainerTemplate basicGetTemplate() {
        return template;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setTemplate(ContainerTemplate newTemplate) {
        ContainerTemplate oldTemplate = template;
        template = newTemplate;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourcelandscapePackage.CONTAINER__TEMPLATE, oldTemplate, template));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourcelandscapePackage.CONTAINER__CONTAINS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getContains()).basicAdd(otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourcelandscapePackage.CONTAINER__CONTAINS:
                return ((InternalEList<?>)getContains()).basicRemove(otherEnd, msgs);
            case ResourcelandscapePackage.CONTAINER__CONFIG_SPEC:
                return ((InternalEList<?>)getConfigSpec()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case ResourcelandscapePackage.CONTAINER__CONTAINS:
                return getContains();
            case ResourcelandscapePackage.CONTAINER__CONFIG_SPEC:
                return getConfigSpec();
            case ResourcelandscapePackage.CONTAINER__TEMPLATE:
                if (resolve) return getTemplate();
                return basicGetTemplate();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case ResourcelandscapePackage.CONTAINER__CONTAINS:
                getContains().clear();
                getContains().addAll((Collection<? extends RuntimeEnvironment>)newValue);
                return;
            case ResourcelandscapePackage.CONTAINER__CONFIG_SPEC:
                getConfigSpec().clear();
                getConfigSpec().addAll((Collection<? extends ConfigurationSpecification>)newValue);
                return;
            case ResourcelandscapePackage.CONTAINER__TEMPLATE:
                setTemplate((ContainerTemplate)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case ResourcelandscapePackage.CONTAINER__CONTAINS:
                getContains().clear();
                return;
            case ResourcelandscapePackage.CONTAINER__CONFIG_SPEC:
                getConfigSpec().clear();
                return;
            case ResourcelandscapePackage.CONTAINER__TEMPLATE:
                setTemplate((ContainerTemplate)null);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case ResourcelandscapePackage.CONTAINER__CONTAINS:
                return contains != null && !contains.isEmpty();
            case ResourcelandscapePackage.CONTAINER__CONFIG_SPEC:
                return configSpec != null && !configSpec.isEmpty();
            case ResourcelandscapePackage.CONTAINER__TEMPLATE:
                return template != null;
        }
        return super.eIsSet(featureID);
    }

} //ContainerImpl
